#include<reg51f.h>
#include<string.h>
//#include "softuart.h"
#define port P0            
#define lcdport P1  //14,13,12,11 pins of lcd and 1.7,1.6,1.5,1.4 of controller

sbit rs=port^0;        //Register select 
sbit rw=port^1;        //Read/Write 
sbit en=port^2;        //Enable pin

//sbit  DATA_RX=P3^2;


unsigned char d[12]=0,i,l,buffer_G,i_G;
unsigned char card_id[12];

unsigned char getc(void);

void delay(unsigned int count)    //Function to provide delay
{
    int i,j;
     for(i=0;i<count;i++)
     for(j=0;j<1100;j++);
}

void lcdcmd(char cmdout)
{
lcdport=cmdout;
rs=0;
rw=0;
en=1;
delay(10);
en=0;
}
 
void lcddata(char dataout)
{
	lcdport=dataout;
rs=1;
rw=0;
en=1;
delay(10);
en=0;
}

void dis_cmd(char cmd_value)
{
	char cmd_value1;
	
		cmd_value1 = cmd_value & 0xF0;		//mask lower nibble because PA4-PA7 pins are used. 
	lcdcmd(cmd_value1);			// send to LCD
 
	cmd_value1 = ((cmd_value<<4) & 0xF0);	//shift 4-bit and mask
	lcdcmd(cmd_value1);			// send to LCD
}						
 
 
void dis_data(char data_value)
{
	char data_value1;
	
	data_value1=data_value&0xF0;
	lcddata(data_value1);
 
	data_value1=((data_value<<4)&0xF0);
	lcddata(data_value1);
}

void lcd_init()	// fuction for intialize 
{
	dis_cmd(0x02);		// to initialize LCD in 4-bit mode.
	dis_cmd(0x28);		//to initialize LCD in 2 lines, 5X7 dots and 4bit mode.
	dis_cmd(0x0C);
	dis_cmd(0x06);
	dis_cmd(0x80);
}


void getdata()
{
for(i=0;i<12;i++)
{
card_id[i]=getc();
}
}



void main(void)
{
unsigned char ch=0;
unsigned char data0[]="CARD ID:";

lcdport=0;
//EA = 1;          // Globally enable interrupts
//Timer_2_Init();
lcd_init();
dis_cmd(0x01);
dis_cmd(0x81);        //Place cursor to second position of first line 
    while(data0[i]!='\0')
   {
dis_data(data0[i]);
delay(20);
i++;
}
while(1)
{
 
getdata();
dis_cmd(0xC1);
while(card_id[i]!='\0')
{
dis_data(card_id[i]);
delay(20);
i++;
}
}
}
